/*
 * Copyright 2010 Nathan Phillip Brink <ohnobinki@ohnopublishing.net>
 *
 * This file is part of libstrl.
 *
 * libstrl is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * libstrl is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with libstrl.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

/**
 * \internal
 * \file
 *   In the case that an OS implements all of the functions which
 *   libstrl provides, a libstrl.so must still be produced. This would
 *   be to support apps which were compiled when the OS didn't provide
 *   every function libstrl provides, potentially, where the
 *   nonpresence of a noop libstrl.so causes a runtime error. In any
 *   case, any library needs at least one object in it. Thus, this
 *   file exists so that the linker can't complain that it's being
 *   asked to make a shared library without any objects in it.
 */
