/*
 * Copyright 2011 Nathan Phillip Brink <ohnobinki@ohnopublishing.net>
 *
 * This file is part of libstrl.
 *
 * libstrl is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * libstrl is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with libstrl.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "strl.h"

#include <stdarg.h>

#include <stdio.h>
/* size_t */
#include <stddef.h>
#include <stdlib.h>

int vasprintf(char **s, const char *format, va_list ap)
{
  int len;
  va_list ap2;

  va_copy(ap2, ap);

  len = vsnprintf(NULL, 0, format, ap);
  if (len < 0)
    goto bad;
  len ++;
  if (len < 0)
    goto bad;

  *s = malloc(len);
  if (!*s)
    goto bad;
  len = vsnprintf(*s, len, format, ap2);
  va_end(ap2);
  return len;

 bad:
  va_end(ap2);
  return -1;
}
