/*
 * Copyright 2010 Nathan Phillip Brink <ohnobinki@ohnopublishing.net>
 *
 * This file is part of libstrl.
 *
 * libstrl is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * libstrl is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with libstrl.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "strl.h"

#include <string.h>
/* size_t */
#include <stddef.h>
#include <wchar.h>

/* changes to this function should likely cause parallel changes in strlcpy() */
size_t wcslcpy(wchar_t *dst, const wchar_t *src, size_t len)
{
  size_t src_len;
  size_t copy_len;

  /* if len is zero, then len - 1 gets us into trouble. */
  if (!len)
    return wcslen(src);

  src_len = wcslen(src);

  copy_len = src_len;
  if (copy_len >= len)
    copy_len = len - 1;

  memcpy(dst, src, sizeof(wchar_t) * copy_len);
  dst[copy_len] = L'\0';

  return src_len;
}
